#include "stdafx.h"
#include "ChkVisa.h"
#include "ChkVisaDlg.h"
#include "afxdialogex.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

#define VFUNC( data, mul, ofsa, ofsb )		( (int)( ( (double)(data) - ofsa ) * mul + ofsb ) )

// These are valid sample-rate to set.
// For DS1302, 1202, 1102
__int64		gi64SRTable[] = { 5000000000, 200000000, 100000000, 50000000, 20000000,
						      10000000, 5000000, 2000000, 1000000, 500000, 200000,
						      100000, 50000, 20000, 10000, 5000, 2000, 1000, 500, 200, 100 }; 

__int64		gi64SRTable1[] = { 5000000000, 100000000, 50000000, 20000000,
						      10000000, 5000000, 2000000, 1000000, 500000, 200000,
						      100000, 50000, 20000, 10000, 5000, 2000, 1000, 500, 200, 100 };


// For DS1002
__int64		gi64SRTableEx[] = { 2500000000, 100000000, 50000000, 20000000,
						      10000000, 5000000, 2000000, 1000000, 500000, 200000,
						      100000, 50000, 20000, 10000, 5000, 2000, 1000, 500, 200, 100 }; 

__int64		gi64SRTableEx1[] = { 2500000000, 50000000, 20000000,
						      10000000, 5000000, 2000000, 1000000, 500000, 200000,
						      100000, 50000, 20000, 10000, 5000, 2000, 1000, 500, 200, 100 };

// For TS2xxx
__int64		gi64SRTableTs[] = { 25000000000, 10000000000, 5000000000, 2500000000, 1000000000, 500000000, 200000000, 100000000, 50000000, 
								20000000, 10000000, 5000000, 2000000, 1000000, 500000, 200000,
								100000, 50000, 20000, 10000, 5000, 2000, 1000, 500, 200, 100 }; 

// These are valid Volt/Div to set.
int			giVoltTable[] = { 10000, 5000, 2000, 1000, 500, 200, 100, 50, 20, 10, 5, 2 };	// Volt(mV)/Div


class CAboutDlg : public CDialogEx
{
public:
	CAboutDlg();
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV supported

protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialogEx(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialogEx)
END_MESSAGE_MAP()


// CChkVisaDlg Dialog




CChkVisaDlg::CChkVisaDlg(CWnd* pParent /*=NULL*/)
	: CDialogEx(CChkVisaDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_iWaveLen = 0;
	m_iBufLen = 64000;
	m_psCH[0] = new short [m_iBufLen/2];
	m_psCH[1] = new short [m_iBufLen/2];
}

void CChkVisaDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CChkVisaDlg, CDialogEx)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDOK, &CChkVisaDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, &CChkVisaDlg::OnBnClickedCancel)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_OPENRM, &CChkVisaDlg::OnBnClickedOpenrm)
	ON_BN_CLICKED(IDC_READ, &CChkVisaDlg::OnBnClickedRead)
	ON_BN_CLICKED(IDC_RESET, &CChkVisaDlg::OnBnClickedReset)
	ON_BN_CLICKED(IDC_QUERY_IDN, &CChkVisaDlg::OnBnClickedQueryIdn)
	ON_BN_CLICKED(IDC_RUN_STOP, &CChkVisaDlg::OnBnClickedRunStop)
	ON_BN_CLICKED(IDC_WAVEFORM, &CChkVisaDlg::OnBnClickedWaveform)
	ON_BN_CLICKED(IDC_WRITE, &CChkVisaDlg::OnBnClickedWrite)
	ON_BN_CLICKED(IDC_TIME_DIV, &CChkVisaDlg::OnBnClickedTimeDiv)
	ON_BN_CLICKED(IDC_VOLT_DIV, &CChkVisaDlg::OnBnClickedVoltDiv)
	ON_BN_CLICKED(IDC_TRIGGER, &CChkVisaDlg::OnBnClickedTrigger)
	ON_BN_CLICKED(IDC_TRIG_MODE, &CChkVisaDlg::OnBnClickedTrigMode)
	ON_BN_CLICKED(IDC_RECORDLENGTH, &CChkVisaDlg::OnBnClickedRecordlength)
	ON_BN_CLICKED(IDC_TRIG_SOURCE, &CChkVisaDlg::OnBnClickedTrigSource)
	ON_BN_CLICKED(IDC_ACQUIRE_MODE, &CChkVisaDlg::OnBnClickedAcquireMode)
END_MESSAGE_MAP()
// CChkVisaDlg message handle routine

HMODULE		ghMod;
typedef	BOOL (__stdcall *PVIOPENRM)();
typedef	BOOL (__stdcall *PVICLOSERM)();
typedef BOOL (__stdcall *PVIWRITE)( LPSTR szCmd );
typedef BOOL (__stdcall *PVIREAD)( LPSTR szRet, int iBufLen );

PVIOPENRM	gpviOpenRM;
PVICLOSERM	gpviCloseRM;
PVIWRITE	gpviWrite;
PVIREAD		gpviRead;

BOOL CChkVisaDlg::OnInitDialog()
{
	CDialogEx::OnInitDialog();
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		BOOL bNameValid;
		CString strAboutMenu;
		bNameValid = strAboutMenu.LoadString(IDS_ABOUTBOX);
		ASSERT(bNameValid);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}


	SetIcon(m_hIcon, TRUE);	
	SetIcon(m_hIcon, FALSE);	

	// AqVisa.dll Initial setting
#ifdef WIN64
	ghMod = LoadLibrary( "AqVisa64.DLL" );
#else
	ghMod = LoadLibrary( "AqVisa.DLL" );
#endif
	gpviOpenRM = (PVIOPENRM)GetProcAddress( ghMod, "viOpenRM" );
	gpviCloseRM = (PVICLOSERM)GetProcAddress( ghMod, "viCloseRM" );
	gpviWrite = (PVIWRITE)GetProcAddress( ghMod, "viWrite" );
	gpviRead = (PVIREAD)GetProcAddress( ghMod, "viRead" );

	return TRUE;
}

void CChkVisaDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialogEx::OnSysCommand(nID, lParam);
	}
}

void CChkVisaDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); 

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CPaintDC	dc(this); // device context for painting
		CPen		*ppenOrg, penCH1, penCH2, penGrid;
		CRgn		rgn;
		int			i;
		int			iOfsX;

		if( m_iWaveLen == 0 )
			return;

		dc.SetBkMode( TRANSPARENT );
		// Create Object
		rgn.CreateRectRgn( 0, 0, 1, 1 );
		penCH1.CreatePen( PS_SOLID, 1, RGB( 255, 255, 0 ) );
		penCH2.CreatePen( PS_SOLID, 1, RGB( 0, 255, 255 ) );
		penGrid.CreatePen( PS_DOT, 1, RGB( 128, 128, 128 ) );

		// Draw Frame & Set the Clipping Region
		dc.Draw3dRect( 10, 10, 322, 242, RGB( 0, 0, 0 ), RGB( 255, 255, 255 ) );
		ppenOrg = dc.SelectObject( &penGrid );
		dc.MoveTo( 170, 11 );
		dc.LineTo( 170, 250 );
		for( i = 11 ; i < 242 ; i += 30 )
		{
			dc.MoveTo( 11, i );
			dc.LineTo( 330, i );
		}
		rgn.SetRectRgn( 11, 11, 331, 251 );
		dc.SelectClipRgn( &rgn );

		// Change Mapped Mode
		dc.SetMapMode( MM_ANISOTROPIC );
			
		iOfsX = 0;
		// Draw Channel 1
		dc.SetWindowExt( m_iWaveLen, m_imvVoltDiv[0] * 8 );			// 8Div * ( CH1 Volt/Div )
		dc.SetViewportExt( 320, 240 );
		dc.SetViewportOrg( 11, 11 );
		dc.SelectObject( &penCH1 );
		dc.MoveTo( iOfsX, (int)( (double)m_imvVoltDiv[0] * ( 4.0f - m_dPosition[0] ) - VFUNC( *m_psCH[0], m_dMul[0], m_dOfsA[0], m_dOfsB[0] ) ) );
		for( i = 0 ; i < m_iWaveLen ; i++ )
			dc.LineTo( i + iOfsX, (int)( (double)m_imvVoltDiv[0] * ( 4.0f - m_dPosition[0] ) - VFUNC( *( m_psCH[0] + i ), m_dMul[0], m_dOfsA[0], m_dOfsB[0] ) ) );
		// Draw Channel 2
		dc.SetWindowExt( m_iWaveLen, m_imvVoltDiv[1] * 8 );			// 8Div * ( CH1 Volt/Div )
		dc.SetViewportExt( 320, 240 );
		dc.SetViewportOrg( 11, 11 );
		dc.SelectObject( &penCH2 );
		dc.MoveTo( iOfsX, (int)( (double)m_imvVoltDiv[1] * ( 4.0f - m_dPosition[1] ) - VFUNC( *m_psCH[1], m_dMul[1], m_dOfsA[1], m_dOfsB[1] ) ) );
		for( i = 0 ; i < m_iWaveLen ; i++ )
			dc.LineTo( i + iOfsX, (int)( (double)m_imvVoltDiv[1] * ( 4.0f - m_dPosition[1] ) - VFUNC( *( m_psCH[1] + i ), m_dMul[1], m_dOfsA[1], m_dOfsB[1] ) ) );

		// =============
		dc.SelectObject( ppenOrg );
		penCH1.DeleteObject();
		penCH2.DeleteObject();
		penGrid.DeleteObject();

		dc.SetMapMode( MM_TEXT );
		dc.SelectClipRgn( NULL );
		rgn.DeleteObject();

		//CDialogEx::OnPaint();
	}
}

HCURSOR CChkVisaDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CChkVisaDlg::OnBnClickedOk()
{
	//CDialogEx::OnOK();
}


void CChkVisaDlg::OnBnClickedCancel()
{
	CDialogEx::OnCancel();
}


void CChkVisaDlg::OnDestroy()
{
	if( m_iBufLen )
	{
		delete [] m_psCH[0];
		delete [] m_psCH[1];
	}
	CDialogEx::OnDestroy();
}


void CChkVisaDlg::OnBnClickedOpenrm()
{
	if( !(*gpviOpenRM)() )
		MessageBox( "DSO AP is not running." );
	else
	{
		GetDlgItem(IDC_OPENRM)->EnableWindow(FALSE);
		GetDlgItem(IDC_READ)->EnableWindow();
		GetDlgItem(IDC_WRITE)->EnableWindow();
		GetDlgItem(IDC_RESET)->EnableWindow();
		GetDlgItem(IDC_QUERY_IDN)->EnableWindow();
		GetDlgItem(IDC_RUN_STOP)->EnableWindow();
		GetDlgItem(IDC_WAVEFORM)->EnableWindow();
		GetDlgItem(IDC_CMD)->EnableWindow();
		GetDlgItem(IDC_TIME_DIV)->EnableWindow();
		GetDlgItem(IDC_VOLT_DIV)->EnableWindow();
		GetDlgItem(IDC_TRIGGER)->EnableWindow();
		GetDlgItem(IDC_TRIG_MODE)->EnableWindow();
		GetDlgItem(IDC_RECORDLENGTH)->EnableWindow();
		GetDlgItem(IDC_TRIG_SOURCE)->EnableWindow();
		GetDlgItem(IDC_ACQUIRE_MODE)->EnableWindow();

	}
}


void CChkVisaDlg::OnBnClickedRead()
{
	char	szRet[64];
	(*gpviRead)( szRet, sizeof(szRet) );
	SetDlgItemText( IDC_RESULT, szRet );
}

void CChkVisaDlg::OnBnClickedReset()
{
	(*gpviWrite)( "*RST" );
	SetDlgItemText( IDC_CMD, "*RST" );
}


void CChkVisaDlg::OnBnClickedQueryIdn()
{
	char	szRet[64];
	(*gpviWrite)( "*IDN?" );
	SetDlgItemText( IDC_CMD, "*IDN?" );
	(*gpviRead)( szRet, sizeof(szRet) );
	SetDlgItemText( IDC_RESULT, szRet );	
}


void CChkVisaDlg::OnBnClickedRunStop()
{
	(*gpviWrite)( "RUNSTOP" );
	SetDlgItemText( IDC_CMD, "RUNSTOP" );
}


void CChkVisaDlg::OnBnClickedWaveform()
{
	int		iCh;
	char	szCmd[64];
	char	szRet[64], *psz;

	// Get DSO Status,  Bit7=1:Data Ready, 0:Not Ready
	(*gpviWrite)( "LOCK" );
	while (true)				//Wait for DSO Data Ready
	{
		(*gpviWrite)( "*STB?" );
		(*gpviRead)( szRet, sizeof(szRet) );
		if( ( (int)strtol( szRet, &psz, 10 ) & 0x80 ) )
			break;
		Sleep(20);
	}

	// Get Record Length
	(*gpviWrite)( "HORIZONTAL:RECORDLENGTH?" );
	(*gpviRead)( szRet, sizeof(szRet) );
	m_iWaveLen = strtol( szRet, &psz, 10 );
	if( m_iWaveLen * 2 > m_iBufLen )
	{
		delete [] m_psCH[0];
		delete [] m_psCH[1];
		m_iBufLen = m_iWaveLen * 2;
		m_psCH[0] = new short [m_iWaveLen];
		m_psCH[1] = new short [m_iWaveLen];
	}

	// Get Sample Time( 1/SR )
	(*gpviWrite)( "WFMPRE:XINCR?" );
	(*gpviRead)( szRet, sizeof(szRet) );
	m_i64SampleTime = _atoi64(szRet);

	for( iCh = 0 ; iCh < 2 ; iCh++ )
	{
		// Change Channel
		wsprintf( szCmd, "DATA:SOURCE:CH%d", iCh+1 );
		(*gpviWrite)( szCmd );

		// Get Volt/Div (mV)
		wsprintf( szCmd, "WFMPRE:VOLTS?");
		(*gpviWrite)( szCmd );
		(*gpviRead)( szRet, sizeof(szRet) );
		m_imvVoltDiv[iCh] = (int)strtod( szRet, &psz );

		// Get Probe x1 or x10
		wsprintf( szCmd, "WFMPRE:PROBE?");
		(*gpviWrite)( szCmd );
		(*gpviRead)( szRet, sizeof(szRet) );
		m_iProbe[iCh] = (int)strtod( szRet, &psz );

		// Get Position(GND), Unit: Division  +4 ~ -4
		wsprintf( szCmd, "WFMPRE:POSITION?");
		(*gpviWrite)( szCmd );
		(*gpviRead)( szRet, sizeof(szRet) );
		m_dPosition[iCh] = strtod( szRet, &psz );

		// Get mul of VFUNC
		(*gpviWrite)( "WFMPRE:YMUL?" );
		(*gpviRead)( szRet, sizeof(szRet) );
		m_dMul[iCh] = strtod( szRet, &psz );

		// Get ofsa of VFUNC
		(*gpviWrite)( "WFMPRE:YOFSA?" );
		(*gpviRead)( szRet, sizeof(szRet) );
		m_dOfsA[iCh] = strtod( szRet, &psz );

		// Get ofsb of VFUNC
		(*gpviWrite)( "WFMPRE:YOFSB?" );
		(*gpviRead)( szRet, sizeof(szRet) );
		m_dOfsB[iCh] = strtod( szRet, &psz );

		// Get DSO Channel Offset//
		wsprintf( szCmd, "WFMPRE:OFFSET?");
		(*gpviWrite)( szCmd );
		(*gpviRead)( szRet, sizeof(szRet) );
		m_dVOfs[iCh] = atof(szRet);

		// Get Waveform RAW Data
		(*gpviWrite)( "WAVEFORM?" );
		(*gpviRead)( (LPSTR)m_psCH[iCh], m_iWaveLen * 2 );
		 
	}
	
	//Get Channel 1 VMax and VMin
	iCh = CHANNEL1;
	double dbVMax = m_psCH[iCh][0];
	double dbVMin = m_psCH[iCh][0];
	for (int i = 0; i < m_iWaveLen; i++)
	{
		if (m_psCH[iCh][i] > dbVMax)
			dbVMax = m_psCH[iCh][i];
		else if (m_psCH[iCh][i] < dbVMin)
			dbVMin = m_psCH[iCh][i];
	}
	double dbVMax_mV = ((dbVMax - m_dOfsA[iCh] ) * m_dMul[iCh] + m_dOfsB[iCh]) * ((double)m_iProbe[iCh]) - (m_dVOfs[iCh] * m_iProbe[iCh]);		
	double dbVMin_mV = ((dbVMin - m_dOfsA[iCh] ) * m_dMul[iCh] + m_dOfsB[iCh]) * ((double)m_iProbe[iCh]) - (m_dVOfs[iCh] * m_iProbe[iCh]);		

	sprintf_s(szCmd, sizeof(szCmd), "CH1 Vmax = %lf mV \r\nCH1 Vmin = %lf mV", dbVMax_mV, dbVMin_mV);
	SetDlgItemText( IDC_RESULT, szCmd );

	InvalidateRect( NULL );
	UpdateWindow();
	(*gpviWrite)( "UNLOCK" );
}

void CChkVisaDlg::OnBnClickedWrite()
{
	CString		str;
	GetDlgItemText( IDC_CMD, str );
	(*gpviWrite)( (LPSTR)(LPCSTR(str)) );
}


void CChkVisaDlg::OnBnClickedTimeDiv()
{
	char	szRet[64];
	char	szBuf[256];
	(*gpviWrite)( "HORIZONTAL:SCALE?" );
	(*gpviRead)( szRet, sizeof(szRet) );
	int iTimeDiv_ps = atoi(szRet);
	if (iTimeDiv_ps > 400E3)	//400 ns
	{
		if (szRet[0] != '1')	//400us 200us 100us 40us 20us....
			iTimeDiv_ps /= 2;
		else
			iTimeDiv_ps = (int)( iTimeDiv_ps * 0.4 );		
	}
	else
	{
		iTimeDiv_ps = (int)400E6;	//400 us
	}
	sprintf_s(szBuf, sizeof(szBuf), "HORIZONTAL:SCALE %dps", iTimeDiv_ps);
	(*gpviWrite)( szBuf );
	SetDlgItemText( IDC_CMD, szBuf );
	sprintf_s(szBuf, sizeof(szBuf), "Last Time Scale is %s\r\nCurrent Time Scale is %dps", szRet, iTimeDiv_ps);
	SetDlgItemText( IDC_RESULT, szBuf );
	
}


void CChkVisaDlg::OnBnClickedVoltDiv()
{
	char *	psz;
	char	szRet[64];
	char	szBuf[256];
	(*gpviWrite)( "CH1:VOLTS?" );//Get Volt Div
	(*gpviRead)( szRet, sizeof(szRet));	
	(*gpviWrite)( "CH1:PROBE?" );//Get Probe 
	(*gpviRead)( szBuf, sizeof(szBuf));
	int iVoltDiv = (int)strtod(szRet, &psz);
	int iProbe = atoi(szBuf);

	int iVoltDiv_new = (int)strtod(szRet, &psz);
	if (iVoltDiv_new > 2)	//2 mV (x1 Probe) / 20mV (x10 Probe)
	{
		if (szRet[0] != '5')		//10V 5V 2V 1V 500mV 200mV....
			iVoltDiv_new /= 2;
		else
			iVoltDiv_new = (int)(iVoltDiv_new * 0.4);		
	}
	else
	{
		iVoltDiv_new = 1000;	//10V (x1 Probe) / 100V (x10 Probe)
	}
	if (iProbe == 10)
		iVoltDiv_new *= iProbe;
	sprintf_s(szBuf, sizeof(szBuf), "CH1:VOLTS %d", iVoltDiv_new);
	(*gpviWrite)( szBuf );
	SetDlgItemText( IDC_CMD, szBuf );
	sprintf_s(szBuf, sizeof(szBuf), "Last Volt Scale is %dmV\r\nCurrent Volt Scale is %dmV", iVoltDiv * iProbe, iVoltDiv_new);
	SetDlgItemText( IDC_RESULT, szBuf );
}

int giTrigger = 0;
void CChkVisaDlg::OnBnClickedTrigger()
{
	char	szRet[64];
	char	szBuf[256];
	const char *szTrigger[]=
	{
		"EDGE RISING",
		"EDGE FALLING",
		"RUNT HIGH L 25ms",
		"RUNT LOW G 50ms",
		"WIDTH HIGH NE 250ns",
		"WIDTH LOW E 25us",
		"VIDEO SCANLINE 15",
		"VIDEO ODD FIELD",
		"VIDEO EVEN FIELD",
		"TIMEOUT High 150 ms",
		0
	};
	(*gpviWrite)( "TRIGGER:A:METHOD?" );//Get Trigger method
	(*gpviRead)( szRet, sizeof(szRet) );
	sprintf_s(szBuf, sizeof(szBuf), "TRIGGER:A:METHOD %s", szTrigger[giTrigger]);
	(*gpviWrite)( szBuf );//Set new Trigger method
	SetDlgItemText( IDC_CMD, szBuf );
	
	sprintf_s(szBuf, sizeof(szBuf), "Last Trigger Method is %s\r\nCurrent Method is %s", szRet, szTrigger[giTrigger]);
	SetDlgItemText( IDC_RESULT, szBuf );

	giTrigger ++;
	if (szTrigger[giTrigger] == 0)
		giTrigger = 0;
}
int giTrigSource = 0;
void CChkVisaDlg::OnBnClickedTrigSource()
{
	char	szRet[64];
	char	szBuf[256];
	const char *szTriggerSource[]=
	{
		"CH1",
		"CH2",
		"EXT",
		0
	};
	(*gpviWrite)( "TRIGGER:A:SOURCE?" );//Get Trigger source
	(*gpviRead)( szRet, sizeof(szRet));
	sprintf_s(szBuf, sizeof(szBuf), "TRIGGER:A:SOURCE %s", szTriggerSource[giTrigSource]);
	(*gpviWrite)( szBuf );
	SetDlgItemText( IDC_CMD, szBuf );
	sprintf_s(szBuf, sizeof(szBuf), "Last Trigger Source is %s\r\nCurrent Source is %s", szRet, szTriggerSource[giTrigSource]);
	SetDlgItemText( IDC_RESULT, szBuf );
	
	giTrigSource++;
	if (szTriggerSource[giTrigSource] == 0)
		giTrigSource = 0;
}


void CChkVisaDlg::OnBnClickedTrigMode()
{
	char	szRet[64];
	char	szBuf[256];
	const char *szTrigMode[]=
	{

		"AUTO",
		"NORMAL",
		"SINGLE",
		0
	};
	(*gpviWrite)( "TRIGGER:A:MODE?" );		//Get Trigger mode
	(*gpviRead)( szRet, sizeof(szRet));
	int iTrigMode = atoi(szRet);			//0: Auto, 1:Normal, 2:Single
	int iNextMode;
	if (iTrigMode == 2)
		iNextMode = 0;
	else
		iNextMode = iTrigMode + 1;
	sprintf_s(szBuf, sizeof(szBuf), "TRIGGER:A:MODE %s", szTrigMode[iNextMode]);
	(*gpviWrite)( szBuf );					//Set Trigger mode
	SetDlgItemText( IDC_CMD, szBuf );
	sprintf_s(szBuf, sizeof(szBuf), "Last Trigger Mode is %s\r\nCurrent Mode is %s", szTrigMode[iTrigMode], szTrigMode[iNextMode]);
	SetDlgItemText( IDC_RESULT, szBuf );

}


void CChkVisaDlg::OnBnClickedRecordlength()
{
	char	szRet[64];
	char	szBuf[256];
	(*gpviWrite)( "TRIGGER:A:MODE?" );		//Get Trigger mode
	(*gpviRead)( szRet, sizeof(szRet) );
	if (atoi(szRet) != 2)	//Not Single Mode
	{
		AfxMessageBox("Record length fix at 10k in Auto/Normal Mode");
		return;
	}
	
	(*gpviWrite)( "HORIZONTAL:RECORDLENGTH?" );		//Get Record length
	(*gpviRead)( szRet, sizeof(szRet));
	int iRecordLength = atoi(szRet);
	int iNextLength;
	if (iRecordLength >= 10E6)
	{
		iNextLength = (int)10E3;
	}
	else
	{
		if (szRet[0] == '5')			//10K 50K 100K 500K 1M 5M 10M 32M 64M
			iNextLength = iRecordLength * 2;
		else
			iNextLength = iRecordLength * 5;
	}
	sprintf_s(szBuf, sizeof(szBuf), "HORIZONTAL:RECORDLENGTH %d", iNextLength);
	(*gpviWrite)( szBuf );		//Set Record length
	SetDlgItemText( IDC_CMD, szBuf );
	sprintf_s(szBuf, sizeof(szBuf), "Last Length %d\r\nCurrent Length %d", iRecordLength, iNextLength);
	SetDlgItemText( IDC_RESULT, szBuf );	
}



int giAcquireMode = 0;
void CChkVisaDlg::OnBnClickedAcquireMode()
{
	char	szRet[64];
	char	szBuf[256];
	const char *szMode[]=
	{
		"Sample",
		"Average",
		"HiRes",
		"Envelope",
		"PeakDetect",
		0
	};
	(*gpviWrite)( "Acquire:Mode?" );//Get Acquire Mode
	(*gpviRead)( szRet, sizeof(szRet) );
	sprintf_s(szBuf, sizeof(szBuf), "Acquire:Mode %s", szMode[giAcquireMode]);
	(*gpviWrite)( szBuf );//Set new Acquire Mode
	SetDlgItemText( IDC_CMD, szBuf );
	
	sprintf_s(szBuf, sizeof(szBuf), "Last Acquire Mode is %s\r\nCurrent Mode is %s", szRet, szMode[giAcquireMode]);
	SetDlgItemText( IDC_RESULT, szBuf );

	giAcquireMode ++;
	if (szMode[giAcquireMode] == 0)
		giAcquireMode = 0;
}
